package com.sckj.project.service.task;

import cn.hutool.json.JSONArray;
import cn.hutool.json.JSONUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.sckj.project.config.ApiUrlConfig;
import com.sckj.project.domain.logistics.LargeBuildingAssetDirs;
import com.sckj.project.domain.logistics.LargeHousingLand;
import com.sckj.project.domain.logistics.LargeOfficeAssetDirs;
import com.sckj.project.domain.logistics.LargeServiceAssetDirs;
import com.sckj.project.service.logistics.*;
import com.sckj.project.util.HttpRequestUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestClientException;

import java.util.List;
@Slf4j
@Service
public class LogisticsTaskService {

    @Autowired
    private ILargePlatHousingLandService largePlatHousingLandService;

    @Autowired
    private ILargePlatLogisticsService largePlatLogisticsService;

    @Autowired
    private ILargePlatLogisticsBuildingAssetService largePlatLogisticsBuildingAssetService;

    @Autowired
    private ILargePlatLogisticsOfficeAssetService largePlatLogisticsOfficeAssetService;

    @Autowired
    private ILargePlatLogisticsServiceAssetService largePlatLogisticsServiceAssetService;

    @Autowired
    private HttpRequestUtil httpRequestUtil;



    public void myTask(){

        /*房产土地表*/
        try {
            JSONArray array = httpRequestUtil.callExternalApi(ApiUrlConfig.getLogisticsHousingUrl());
            if (array == null){
                return;
            }
            List<LargeHousingLand> list = array.toList(LargeHousingLand.class);
            if (list.size() < 1){
                return;
            }
            largePlatHousingLandService.remove(new LambdaQueryWrapper<>());
            largePlatHousingLandService.saveBatch(list);
        } catch (Exception e) {
            e.getMessage();
        }

        /*后勤运行监控中心表*/
        largePlatLogisticsService.saveOrUpdate(httpRequestUtil.callExternalApi(ApiUrlConfig.getLogisticsUrl()));

        /*楼宇设备表*/
        try {
            JSONArray array = httpRequestUtil.callExternalApi(ApiUrlConfig.getLogisticsBuildingAssetUrl());
            if (array == null){
                return;
            }
            List<LargeBuildingAssetDirs> list = array.toList(LargeBuildingAssetDirs.class);
            if (list.size() < 1){
                return;
            }
            largePlatLogisticsBuildingAssetService.remove(new LambdaQueryWrapper<>());
            largePlatLogisticsBuildingAssetService.saveBatch(list);
        } catch (Exception e) {
            e.getMessage();
        }

        /*办公资产表*/
        try {
            JSONArray array = httpRequestUtil.callExternalApi(ApiUrlConfig.getLogisticsOfficeAssetUrl());
            if (array == null){
                return;
            }
            List<LargeOfficeAssetDirs> list = array.toList(LargeOfficeAssetDirs.class);
            if (list.size() < 1){
                return;
            }
            largePlatLogisticsOfficeAssetService.remove(new LambdaQueryWrapper<>());
            largePlatLogisticsOfficeAssetService.saveBatch(list);
        } catch (Exception e) {
            e.getMessage();
        }

        /*服务设备表*/
        try {
            JSONArray array = httpRequestUtil.callExternalApi(ApiUrlConfig.getLogisticsServiceAssetUrl());
            if (array == null){
                return;
            }
            List<LargeServiceAssetDirs> list = array.toList(LargeServiceAssetDirs.class);
            if (list.size() < 1){
                return;
            }
            largePlatLogisticsServiceAssetService.remove(new LambdaQueryWrapper<>());
            largePlatLogisticsServiceAssetService.saveBatch(list);
        } catch (Exception e) {
            e.getMessage();
        }

    }
}
